﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DockManager;
using System.Windows.Media.Animation;
using System.Data;
using Infragistics.Windows;
using System.Globalization;

namespace WpfMDI
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        //private XamDockManager xamDockManager1;

        public Window1()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            DataTable t = GenerateData().Tables[0];
            xamDataGrid1.DataSource = t.DefaultView;
        }

        public DataSet GenerateData()
        {
            DataSet ds = new DataSet();
            DataTable dt = ds.Tables.Add("TopMovies");

            dt.Columns.Add("Selected", typeof(bool));
            dt.Columns.Add("Title", typeof(string));
            dt.Columns.Add("Running", typeof(string));
            dt.Columns.Add("MPAA", typeof(string));
            dt.Columns.Add("Critics", typeof(string));
            dt.Columns.Add("Valid", typeof(bool));
            dt.Columns.Add("Load", typeof(decimal));
            dt.Columns.Add("Date", typeof(DateTime));

            dt.Rows.Add(new object[] { false, "Open Season", "1 hr. 40 min.", "PG", "C", true, 4.7, DateTime.Now });
            dt.Rows.Add(new object[] { false, "Gridiron Gang", "120 min.", "PG-13", "C+", true, 7.2, DateTime.Now });
            dt.Rows.Add(new object[] { false, "The Illusionist", "1 hr. 49 min.", "PG-13", "B", false, 78.3, DateTime.Now });
            dt.Rows.Add(new object[] { false, "Pirates of the Caribbean: Dead Man's Chest", "145 min.", "PG-13", "B-", true, 78, DateTime.Now });
            dt.Rows.Add(new object[] { false, "Open Season", "1 hr. 40 min.", "PG", "C", true, 34, DateTime.Now });
            dt.Rows.Add(new object[] { false, "Gridiron Gang", "120 min.", "PG-13", "C+", true, 676, DateTime.Now });
            dt.Rows.Add(new object[] { true, "The Illusionist", "1 hr. 49 min.", "PG-13", "B", false, 46, DateTime.Now });
            dt.Rows.Add(new object[] { false, "Pirates of the Caribbean: Dead Man's Chest", "145 min.", "PG-13", "B-", true, 345, DateTime.Now });
            dt.Rows.Add(new object[] { false, "Open Season", "1 hr. 40 min.", "PG", "C", true, 23, DateTime.Now });
            dt.Rows.Add(new object[] { false, "Gridiron Gang", "120 min.", "PG-13", "C+", true, 53, DateTime.Now });
            dt.Rows.Add(new object[] { true, "The Illusionist", "1 hr. 49 min.", "PG-13", "B", false, 67, DateTime.Now });
            
            return ds;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            this.xamDataGrid1.IsEnabled = false;
        }

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            this.xamDataGrid1.IsEnabled = true;

            ContentPane pane = new ContentPane();
            pane.Content = new StackPanel();
            pane.Header = "aaaaaaa";
            pane.OptionsMenuOpening += new EventHandler<Infragistics.Windows.DockManager.Events.PaneOptionsMenuOpeningEventArgs>(pane_OptionsMenuOpening);

            tabControl.Items.Add(pane);
            pane.Activate();
        }

        void pane_OptionsMenuOpening(object sender, Infragistics.Windows.DockManager.Events.PaneOptionsMenuOpeningEventArgs e)
        {
            ContentPane cp = e.OriginalSource as ContentPane;
            Infragistics.Shared.ResourceCustomizer res = Infragistics.Windows.Resources.Customizer;

            e.Items.Clear();

            MenuItem menuItem = new MenuItem();
            menuItem.Command = Infragistics.Windows.DockManager.ContentPaneCommands.Close;
            menuItem.CommandParameter = cp;
            menuItem.CommandTarget = cp;
            menuItem.Header = res.GetCustomizedString("ClosePaneMenuItem");// Properties.Resources.CloseMenuItem;
            e.Items.Add(menuItem);

            menuItem = new MenuItem();
            menuItem.Command = Infragistics.Windows.DockManager.ContentPaneCommands.CloseAllButThis;
            menuItem.CommandParameter = cp;
            menuItem.CommandTarget = cp;
            menuItem.Header = "Close all but this";
            e.Items.Add(menuItem);

            e.Items.Add(new Separator());

            menuItem = new MenuItem();
            menuItem.Command = Infragistics.Windows.DockManager.ContentPaneCommands.MoveToNewHorizontalGroup;
            menuItem.CommandParameter = cp;
            menuItem.CommandTarget = cp;
            menuItem.Header = "New Horizontal Group";
            e.Items.Add(menuItem);

            menuItem = new MenuItem();
            menuItem.Command = Infragistics.Windows.DockManager.ContentPaneCommands.MoveToNewVerticalGroup;
            menuItem.CommandParameter = cp;
            menuItem.CommandTarget = cp;
            menuItem.Header = "New Vertical Group";
            e.Items.Add(menuItem);
        }
    }

    #region Convertor
    public class BooleanConverter : IValueConverter
    {
        public static BooleanConverter Instance = new BooleanConverter();

        #region IValueConverter Members

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (targetType == typeof(string))
            {
                if (value is bool)
                {
                    if ((bool)value == true)
                    {
                        return new CheckBox { IsChecked = true };
                    }
                }

                return "Nein";
            }
            return value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return new NotImplementedException();
        }

        #endregion
    }

    public class DateTimeConverter : IValueConverter
    {
        public static DateTimeConverter Instance = new DateTimeConverter();

        #region IValueConverter Members

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (targetType == typeof(string))
            {
                if (value is DateTime)
                {
                    //System.Globalization.CultureInfo ci = System.Threading.Thread.CurrentThread.CurrentCulture;
                    DateTimeFormatInfo ci = new DateTimeFormatInfo();
                    ci.DateSeparator = "-";
                    return DateTime.Parse(value.ToString()).ToString("D", ci);
                }
            }
            return value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return new NotImplementedException();
        }

        #endregion
    }

    public class DecimalConverter : IValueConverter
    {
        public static DecimalConverter Instance = new DecimalConverter();

        #region IValueConverter Members

        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (targetType == typeof(string))
            {
                if (value is Decimal)
                {
                    //System.Globalization.CultureInfo ci = System.Threading.Thread.CurrentThread.CurrentCulture;

                    NumberFormatInfo ci = new NumberFormatInfo();
                    ci.NumberDecimalDigits = 5;
                    return Decimal.Parse(Decimal.Parse(value.ToString()).ToString("N", ci));
                    //return String.Format(ci, "{0:C}", value);
                }
            }
            return value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return new NotImplementedException();
        }

        #endregion
    }
    #endregion
}
